# Adding New Master

## Overview

For creating a new master in MDMS, create the JSON file with the master data and configure the newly created master in the master config file.

## Pre-requisites

Before proceeding with the configuration, make sure the following pre-requisites are met -

* User with permission to edit the git repository where MDMS data is configured.

## Deployment Details

After adding the new master, the MDMS service needs to be restarted to read the newly added data.

## Configuration Details

### **Creating Master JSON**

The new JSON file needs to contain 3 keys as shown in the below code snippet.\
The new master can be created either State-wise or ULB-wise. Tenant id and config in the master config file determine this.

```
{
  "tenantId": "< TENANT ID >",
  "moduleName": "< MODULE NAME >",
  "< MASTER NAME >": []
}
```

### **Configuring The Master Config File**

The Master config file is structured as below. Each key in the Master config is a module and each key in the module is a master.

```
{
  "<module1>":{
    "<master1>":{},
    "<master2>":{},
    ...
  },
  "<module2>":{
    <master3>:{},
    <master4>:{},
    ...
  },
  ...
}
```

Each master contains the following data and the  keys are self-explanatory

```
"master":{
    "masterName": "<>",
    "isStateLevel": true,
    "uniqueKeys": []
}
```

## Reference Docs

### Doc Links

| Description                 | Link                                                                                                                         |
| --------------------------- | ---------------------------------------------------------------------------------------------------------------------------- |
| Sample Master file          | <https://github.com/egovernments/playground-mdms-data/blob/master/data/pg/PropertyTax/ConstructionType.json>                 |
| Sample Master configuration | <https://github.com/egovernments/playground-mdms-data/blob/081a232c26be11a9d803d4490e01d49a7e35985c/master-config.json#L561> |

[![Creative Commons License](https://i.creativecommons.org/l/by/4.0/80x15.png)](http://creativecommons.org/licenses/by/4.0/)All content on this page by [eGov Foundation ](https://egov.org.in/)is licensed under a [Creative Commons Attribution 4.0 International License](http://creativecommons.org/licenses/by/4.0/).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.digit.org/local-governance/deploy/configure-digit/setting-up-master-data/adding-new-master.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
